  
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>

  int sock;



FILE *infile, *outfile;
int sock, numforks = 0, timesup = 0, port = 80;

typedef struct {
        unsigned char type;
        unsigned char flags;
        unsigned short length;
} NETBIOS_HEADER;

typedef struct {
        unsigned char protocol[4];
        unsigned char command;
        unsigned short status;
        unsigned char reserved;
        unsigned char  flags;
        unsigned short flags2;
        unsigned char  pad[12];
        unsigned short tid;
        unsigned short pid;
        unsigned short uid;
        unsigned short mid;
} SMB_HEADER;
int tot=0;
int OWNED = 0;
char last[120];
pid_t childs[100];
struct sockaddr_in addr1;
struct sockaddr_in addr2;

int
Connect(int fd, char *ip, unsigned int port, unsigned int time_out)
{
	        /* ripped from no1 */

	        int                      flags;
		        int                      select_status;
			        fd_set                   connect_read, connect_write;
				        struct timeval           timeout;
					        int                      getsockopt_length = 0;
						        int                      getsockopt_error = 0;
							        struct sockaddr_in       server;
								        bzero(&server, sizeof(server));
									        server.sin_family = AF_INET;
										        inet_pton(AF_INET, ip, &server.sin_addr);
											        server.sin_port = htons(port);

												        if((flags = fcntl(fd, F_GETFL, 0)) < 0) {
														                close(fd);
																                return -1;
																		        }

													      if(fcntl(fd, F_SETFL, flags | O_NONBLOCK) < 0) {
														                      close(fd);
																                      return -1;
																		              }

													              timeout.tv_sec = time_out;
														              timeout.tv_usec = 0;
															              FD_ZERO(&connect_read);
																              FD_ZERO(&connect_write);
																	              FD_SET(fd, &connect_read);
																		              FD_SET(fd, &connect_write);

																			              if((connect(fd, (struct sockaddr *) &server, sizeof(server))) < 0) {
																					                      if(errno != EINPROGRESS) {
																								                              close(fd);
																											                              return -1;
																														                      }
																							              }
																				              else {
																						                      if(fcntl(fd, F_SETFL, flags) < 0) {
																									                              close(fd);
																												                              return -1;
																															                      }

																								                      return 1;

																										              }

																					              select_status = select(fd + 1, &connect_read, &connect_write, NULL, &timeout);

																						              if(select_status == 0) {
																								                      close(fd);
																										                      return -1;
																												           }

																							              if(select_status == -1) {
																									                      close(fd);
																											                      return -1;
																													              }

																								              if(FD_ISSET(fd, &connect_read) || FD_ISSET(fd, &connect_write)) {
																										                      if(FD_ISSET(fd, &connect_read) && FD_ISSET(fd, &connect_write))
																													       {
																														                               getsockopt_length = sizeof(getsockopt_error);

																																	                               if(getsockopt(fd, SOL_SOCKET, SO_ERROR, &getsockopt_error, &getsockopt_length) < 0) {
																																					                                       errno = ETIMEDOUT;
																																									                                       close(fd);
																																													                                       return -1;
																																																	                               }

																																				                               if(getsockopt_error == 0) {
																																								                                       if(fcntl(fd, F_SETFL, flags) < 0) {
																																													                                               close(fd);
																																																		                                               return -1;
																																																							                                       }
																																												                                       return 1;
																																																                               }

																																							                               else {
																																											                                       errno = getsockopt_error;
																																															                                       close(fd);
																																																			                                       return (-1);
																																																							                                       }

																																										                               }
																												              }
																									              else {
																											                      close(fd);
																													                      return 1;
																															              }

																										              if(fcntl(fd, F_SETFL, flags) < 0) {
																												                      close(fd);
																														                      return -1;
																																              }
																											              return 1;
}


int
read_timer(int fd, unsigned int time_out)
{

	        /* ripped from no1 */

	        int                      flags;
		        int                      select_status;
			        fd_set                   fdread;
				        struct timeval           timeout;

					        if((flags = fcntl(fd, F_GETFL, 0)) < 0) {
							                close(fd);
									                return (-1);
											        }

						        if(fcntl(fd, F_SETFL, flags | O_NONBLOCK) < 0) {
								                close(fd);
										                return (-1);
												        }

							        timeout.tv_sec = time_out;
								        timeout.tv_usec = 0;
									        FD_ZERO(&fdread);
										        FD_SET(fd, &fdread);
											        select_status = select(fd + 1, &fdread, NULL, NULL, &timeout);

												        if(select_status == 0) {
														                close(fd);
																                return (-1);
																		        }

													        if(select_status == -1) {
															                close(fd);
																	              return (-1);
																		              }

														        if(FD_ISSET(fd, &fdread)) {

																                if(fcntl(fd, F_SETFL, flags) < 0) {
																			                        close(fd);
																						                        return -1;
																									                }

																		                return 1;

																				        }
															        else {
																	                close(fd);
																			                return 1;

																					        }
}

int
write_timer(int fd, unsigned int time_out)
{

	        /* ripped from no1 */

	        int                      flags;
		        int                      select_status;
			        fd_set                   fdwrite;
				        struct timeval           timeout;
					        if((flags = fcntl(fd, F_GETFL, 0)) < 0) {
							                close(fd);
									                return (-1);
											        }

						        if(fcntl(fd, F_SETFL, flags | O_NONBLOCK) < 0) {
								                close(fd);
										                return (-1);
												        }

							        timeout.tv_sec = time_out;
								        timeout.tv_usec = 0;
									        FD_ZERO(&fdwrite);
										        FD_SET(fd, &fdwrite);

											        select_status = select(fd + 1, NULL, &fdwrite, NULL, &timeout);

												        if(select_status == 0) {
														                close(fd);
																                return -1;
																		        }

													        if(select_status == -1) {
															                close(fd);
																	                return -1;
																			        }

														        if(FD_ISSET(fd, &fdwrite)) {
																                if(fcntl(fd, F_SETFL, flags) < 0) {
																			                        close(fd);
																						                        return -1;
																									                }
																		                return 1;
																				   }
															        else {
																	                close(fd);
																			                return -1;
																					        }
}



int
is_samba(char *ip, unsigned long time_out)
{
        char
        nbtname[]= /* netbios name packet */
        {
                0x80,0xf0,0x00,0x10,0x00,0x01,0x00,0x00,
                0x00,0x00,0x00,0x00,0x20,0x43,0x4b,0x41,
                0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
                0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
                0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
                0x41,0x41,0x41,0x41,0x41,0x00,0x00,0x21,
                0x00,0x01
        };

        unsigned char recv_buf[1024];
        unsigned char *ptr;

        int i = 0;
        int s = 0;

        unsigned int total = 0;

        if ((s = socket(PF_INET, SOCK_DGRAM, 17)) <= 0) return -1;

if(Connect(s, ip, 137, time_out) == -1) {
	                close(s);
			                return -1;
					        }

        memset(recv_buf, 0x00, sizeof(recv_buf));

        if(write_timer(s, time_out) == 1) {
                if (write(s, nbtname, sizeof(nbtname)) <= 0) {
                        close(s);
                        return -1;
                }
        }

        if (read_timer(s, time_out) == 1) {
                if (read(s, recv_buf, sizeof(recv_buf)) <= 0) {
                        close(s);
                        return -1;
                }

                ptr = recv_buf + 57;
                total = *(ptr - 1); /* max names */

                while(ptr < recv_buf + sizeof(recv_buf)) {
                        ptr += 18;
                        if (i == total) {

                                ptr -= 19;                      

                                if ( *(ptr + 1) == 0x00 && *(ptr + 2) == 0x00 && *(ptr + 3) == 0x00 &&
                                     *(ptr + 4) == 0x00 && *(ptr + 5) == 0x00 && *(ptr + 6) == 0x00) {
                                        close(s);
                                        return 0;
                                }

                                close(s);
                                return 1;
                        }

                        i++;    
                }

        }
        close(s);
        return -1;
}






void alarm_handler(int signal){
close(sock);
exit(0);
}

void usage(char *s)
{
    printf("usage: %s <infile> <outfile> <children>\n", s);
    exit(EXIT_SUCCESS);
}
int scan(char *host)
{
if (!is_samba(host,10))
	fprintf(outfile,"%s\n",host);

    return 1;
}


int main(int argc, char *argv[])
{
    char buf[1024];
    time_t start;

    if (argc < 4)
        usage(argv[0]);

    if (!(infile = fopen(argv[1], "r")) || !(outfile = fopen(argv[2], "a")))
    {
        fprintf(stderr, "Unable to open file(s) for reading! Exiting.\n");
        exit(EXIT_FAILURE);
    }
    printf("# Trying to identify hosts\n");
    start = time(0);
    while (!feof(infile))
    {
        fgets((char *)&buf, sizeof(buf), infile);
        if (buf[strlen (buf) - 1] == '\n')
            buf[strlen (buf) - 1] = '\0';
        if (!(fork()))
        {
	    signal(SIGALRM,alarm_handler);
alarm(10);
            scan(buf);
alarm(0);
        	close(sock);    
	exit(0);
        }
        else
        {
            numforks++;
            if (numforks > atoi(argv[3]))
                for (numforks; numforks > atoi(argv[3]); numforks--)
                    wait(NULL);
        }
    }
    fclose(infile);
    fclose(outfile);
    printf("# Done! completed in %lu seconds\n", (time(0) - start));
    exit(EXIT_SUCCESS);
}
